"""

This addon shows you, how to make generally an app and how to make options with own blocks

"""

'''
 * imports
'''	

import es
import psyco
psyco.full()
import time
import usermsg
import popuplib
import gamethread

'''
 * import applib
'''	

import applib as app

def load():
	global AppFunc
	global option
	global option1
	AppFunc = app.NewApp("Hud-Clock") # reg. a new app "HudClock"
	option = AppFunc.NewOption("Time Type", "24") # add a option names "Time Type" with the standard value "24"
	option.AddValue("12", "12 Hour Clock") # add the value "12" to the option with the description "12 Hour Clock" 
	option.AddValue("24", "24 Hour Clock") # add the value "24" to the option with the description "24 Hour Clock" 
	option1 = AppFunc.NewOption("Extra Time", "0", True, TimeZoneBlock) # add a option names "Extra Time" with the standard value "0" and execute the block "TimeZoneBlock"
	AppFunc.Author("Popoklopsi") # set the author to "Popoklopsi"
	AppFunc.Version("1.0") # set the version to "1.0"
	AppFunc.Description("Show the current Time in the HUD") # set the description to "Show the current Time in the HUD"
	gamethread.delayed(2, timer)
	
def unload():
	gamethread.cancelDelayed("timer")
	
def TimeZoneBlock(userid):
	'''
	 * the handle for the option "Extra Time"
	'''	
	timezonepop = popuplib.create("TimeZones")
	timezonepop.addline("Add / Subtract Time")
	timezonepop.addline("Now: + %i Hours" % int(option1.GetOptionValue(userid))) # get the value of the option "Extra Time"
	timezonepop.addline("--------------------------")
	timezonepop.addline("->1. + Time ")
	timezonepop.addline("->2. - Time ")
	timezonepop.addline("->3. Standard ")
	timezonepop.addline("--------------------------")
	timezonepop.addline("0. Close")
	timezonepop.menuselect = TimeChoose
	timezonepop.send(userid)
	
def TimeChoose(userid, choice, popupid):
	if choice == 1:
		pluszones = popuplib.easymenu("pluszones", None, PushZonePlus)
		pluszones.settitle("Add Time")
		for x in xrange(12):
			thetime = int(x+1)
			pluszones.addoption(thetime, "+ %i" % thetime)
		pluszones.send(userid)
	if choice == 2:
		minuszones = popuplib.easymenu("minuszones", None, PushZoneMinus)
		minuszones.settitle("Subtract Time")
		for x in xrange(12):
			thetime = int(x+1)
			minuszones.addoption(thetime*-1, "- %i" % thetime)
		minuszones.send(userid)
	if choice == 3:
		if AppFunc.CheckTimer(userid): # check if the users timelimit is on
			AppFunc.TurnTimerOn(userid) # turn the timer on
			app.SayText("Updated the #lightgreenValue to Standard", userid) # say "Changed to Standard" to the user
			option1.UpdateUserValue(userid, "0") # update the value of the option "Extra Time"
			TimeZoneBlock(userid)
		
def PushZonePlus(userid, choice, popupid):
	if AppFunc.CheckTimer(userid): # check if the users timelimit is on
		AppFunc.TurnTimerOn(userid) # turn the timer on
		app.SayText("Updated the #lightgreenValue to %s" % str(choice), userid) # say "Changed to X" to the user
		option1.UpdateUserValue(userid, choice) # update the value of the option "Extra Time"
	TimeZoneBlock(userid)
	
def PushZoneMinus(userid, choice, popupid):
	if AppFunc.CheckTimer(userid): # check if the users timelimit is on
		AppFunc.TurnTimerOn(userid) # turn the timer on
		app.SayText("Updated the #lightgreenValue to %s" % str(choice), userid) # say "Changed to X" to the user
		option1.UpdateUserValue(userid, choice) # update the value of the option "Extra Time"
	TimeZoneBlock(userid)
	
def timer():
	for x in es.getUseridList():
		if AppFunc.UserRunApp(x): # check if the user run the app
			typ = option.GetOptionValue(x) # get the value of the option "Time Type"
			timeadd = int(option1.GetOptionValue(x)) # get the value of the option "Extra Time"
			if typ == "12":
				zone = time.strftime("%p")
				if int(time.strftime("%I")) + timeadd >= 12:
					newtime = 12 - int(time.strftime("%I"))
					timeadd = timeadd - newtime
					newtime = 0 + timeadd
					if zone.lower() == "pm":
						zone = "AM"
					elif zone.lower() == "am":
						zone = "PM"
					usermsg.hudhint(x, "It's %s:%s %s o'clock" % (str(newtime), time.strftime("%M:%S"), zone))
				elif int(time.strftime("%I")) + timeadd < 0:
					newtime = (int(time.strftime("%I")) + timeadd) * -1
					newtime = 12 - newtime
					if zone.lower() == "pm":
						zone = "AM"
					elif zone.lower() == "am":
						zone = "PM"
					usermsg.hudhint(x, "It's %s:%s %s o'clock" % (str(newtime), time.strftime("%M:%S"), zone))
				else:
					newtime = int(time.strftime("%I")) + timeadd
					usermsg.hudhint(x, "It's %s:%s o'clock" % (str(newtime), time.strftime("%M:%S %p")))
			if typ == "24":
				if int(time.strftime("%H")) + timeadd >= 24:
					newtime = 24 - int(time.strftime("%H"))
					timeadd = timeadd - newtime
					newtime = 0 + timeadd
					usermsg.hudhint(x, "It's %s:%s o'clock" % (str(newtime), time.strftime("%M:%S")))
				elif int(time.strftime("%H")) + timeadd < 0:
					newtime = (int(time.strftime("%H")) + timeadd) * -1
					newtime = 24 - newtime
					usermsg.hudhint(x, "It's %s:%s o'clock" % (str(newtime), time.strftime("%M:%S")))
				else:
					newtime = int(time.strftime("%H")) + timeadd
					usermsg.hudhint(x, "It's %s:%s o'clock" % (str(newtime), time.strftime("%M:%S")))
	gamethread.delayedname(1, "timer", timer)