import es
import psyco
psyco.full()
import os
import shutil
import gamethread
import popuplib
import applib as app
from configobj import ConfigObj

AddonPath = es.getAddonPath("cssapps")

config = es.getAddonPath("cssapps") + "/cssapps_config.cfg"
configload = ConfigObj(config)

DebugLevel = int(configload["debug_level"])
MyAppsCMD = configload["my_apps_cmd"]
AppListCMD = configload["app_list_cmd"]
AdminList = configload["admins"]
AdminCmd = configload["admin_cmd"]

AppOptions = {}
CurrentApp = {}
CurrentOpt = {}

info = es.AddonInfo()
info.name = "CSS APPS"
info.version = "1.0"
info.author = "Popoklopsi"
info.url = "http://www.pup-board.de/"
info.basename = "cssapps"
info.description = "Apps for CSS"
es.set(info.basename,info.version)
es.makepublic(info.basename)

def load():
	if DebugLevel:
		app.PrintToLogFree("\n############################################################## -START OF CSS APPS- ##############################################################\n")
	app.debug = DebugLevel
	adminpop = popuplib.create("adminmenu")
	adminpop.addline("Css Apps Adminmenu")
	adminpop.addline("---------------------------")
	adminpop.addline("->1. Turn an App On")
	adminpop.addline("->2. Turn an App Off")
	adminpop.addline("->3. Reset an App")
	adminpop.addline("->4. Delete an App")
	adminpop.addline("---------------------------")
	adminpop.addline("0.Close")
	adminpop.menuselect = AdminChoose
	app.InIDB(AddonPath)
	es.regsaycmd(AppListCMD, "cssapps/GetAppList", "show the app List")
	es.regsaycmd(AdminCmd, "cssapps/AdminMenu", "open admin menu")
	es.regsaycmd(MyAppsCMD, "cssapps/UserAppList", "show the users app List")
	
def es_map_start(ev):
	if DebugLevel:
		app.PrintToLogFree("\n############################################################### -MAP CHANGED- ###############################################################\n")
	stop_apps()
	
def player_activate(ev):
	app.InIUser(ev["userid"])
	
def round_start(ev):
	app.SayText("%s #lightgreenfor an #greenApp List" % AppListCMD)
	app.SayText("%s #lightgreenfor a List of #greenyour running Apps" % MyAppsCMD)
	
def load_apps(appname = None):
	if not appname:
		if app.CheckDebug("app"):
			app.PrintToLog("Load Apps ...")
		for x in os.listdir(AddonPath):
			if os.path.isdir(AddonPath + "/" + x):
				if x != "disabled":
					es.server.queuecmd("es_load cssapps/%s" % x)
					if app.CheckDebug("app"):
						app.PrintToLog("Load now App %s ..." % x)
	else:
		es.server.queuecmd("es_load cssapps/%s" % appname)
		if app.CheckDebug("app"):
			app.PrintToLog("Load now App %s ..." % appname)
			
def stop_apps(appname = None):
	if not appname:
		if app.CheckDebug("app"):
			app.PrintToLog("Stop Apps ...")
		for x in os.listdir(AddonPath):
			if os.path.isdir(AddonPath + "/" + x):
				if x != "disabled":
					es.server.queuecmd("es_unload cssapps/%s" % x)
					if app.CheckDebug("app"):
						app.PrintToLog("Stopped App %s" % x)
		app.AppList = []
		app.AppOptions = {}
		app.UsedPeoples = {}
		app.NeedDBs = {}
		app.UserRunTheApp = {}
		app.UserApps = {}
		load_apps()
	else:
		es.server.queuecmd("es_unload cssapps/%s" % appname)
		app.AppList.remove(appname)
		if app.CheckDebug("app"):
			app.PrintToLog("Stopped App %s" % appname)
	
def AdminMenu():
	userid = str(es.getcmduserid())
	steamid = es.getplayersteamid(userid)
	if steamid in AdminList:
		popuplib.send("adminmenu", userid)
		
def AdminChoose(userid, choice, popupid):
	if choice == 1:
		choice1 = popuplib.easymenu("appstoload", None, LoadApp)
		choice1.settitle("Choose an App to load")
		for x in os.listdir(AddonPath):
			if os.path.isdir(AddonPath + "/" + x):
				if x != "disabled":
					if x not in app.AppList:
						choice1.addoption(x, x)
		choice1.send(userid)
	if choice == 2:
		choice2 = popuplib.easymenu("appstounload", None, UnloadApp)
		choice2.settitle("Choose an App to unload")
		for x in app.AppList:
			choice2.addoption(x, x)
		choice2.send(userid)
	if choice == 3:
		choice3 = popuplib.easymenu("appstoreset", None, ResetApp)
		choice3.settitle("Choose an App to reset")
		for x in app.AppList:
			choice3.addoption(x, x)
		choice3.send(userid)
	if choice == 4:
		choice4 = popuplib.easymenu("appstodelete", None, DeleteApp)
		choice4.settitle("Choose an App to delete")
		for x in app.AppList:
			choice4.addoption(x, x)
		choice4.send(userid)
		
def LoadApp(userid, choice, popupid):
	load_apps(choice)
	steamid = es.getplayersteamid(userid)
	gamethread.delayed(2, InITheUsers, (choice))
	app.SayText("Steamid %s: Loaded App %s" % (steamid, choice), userid)
	popuplib.send("adminmenu", userid)
		
def UnloadApp(userid, choice, popupid):
	steamid = es.getplayersteamid(userid)
	if choice in app.AppList:
		stop_apps(choice)
		for x in es.getUseridList():
			if str(x) in app.UserRunTheApp.keys():
				if choice in app.UserRunTheApp[str(x)].keys():
					del (app.UserRunTheApp[str(x)][choice])
		if choice in app.UserApps.keys():
			del (app.UserApps[choice])
		if choice in app.AppOptions.keys():
			del(app.AppOptions[choice])
		if choice in app.UsedPeoples.keys():
			del(app.UsedPeoples[choice])
		app.SayText("Steamid %s: Stopped App %s" % (steamid, choice), userid)
		popuplib.send("adminmenu", userid)
	
def ResetApp(userid, choice, popupid):
	steamid = es.getplayersteamid(userid)
	if choice in app.AppList:
		stop_apps(choice)
		app.EmptyTable(choice)
		app.SayText("Steamid %s: Reset App %s" % (steamid, choice), userid)
		for x in es.getUseridList():
			if str(x) in app.UserRunTheApp.keys():
				if choice in app.UserRunTheApp[str(x)].keys():
					del (app.UserRunTheApp[str(x)][choice])
		if choice in app.UserApps.keys():
			del (app.UserApps[choice])
		if choice in app.AppOptions.keys():
			del(app.AppOptions[choice])
		if choice in app.UsedPeoples.keys():
			del(app.UsedPeoples[choice])
		load_apps(choice)
		gamethread.delayed(2, InITheUsers, (choice))
		popuplib.send("adminmenu", userid)
		
def InITheUsers(appname):
	for x in es.getUseridList():
		app.InIUser(x, appname)
		
def DeleteApp(userid, choice, popupid):
	steamid = es.getplayersteamid(userid)
	if choice in app.AppList:
		stop_apps(choice)
		shutil.rmtree(AddonPath + '/' + choice)
		app.DeleteTable(choice)
		app.SayText("Steamid %s: Deleted App %s" % (steamid, choice), userid)
		popuplib.send("adminmenu", userid)
	
def GetAppList():
	userid = str(es.getcmduserid())
	steamid = es.getplayersteamid(userid)
	if app.CheckDebug("player"):
		app.PrintToLog("Steamid %s: opened App List" % steamid)
	counter = 0
	liste = app.AppList
	if liste:
		listenpop = popuplib.easymenu("apps", None, PushApp)
		listenpop.settitle("App List")
		for x in liste:
			if app.IsUseridAllowed(userid, x):
				counter = 1
				listenpop.addoption(x, x)
		if counter:
			listenpop.send(userid)
		else:
			app.SayText("There are #lightgreenno Apps installed now", userid)
	else:
		app.SayText("There are #lightgreenno Apps installed now", userid)
		
def UserAppList():
	userid = str(es.getcmduserid())
	steamid = es.getplayersteamid(userid)
	if app.CheckDebug("player"):
		app.PrintToLog("Steamid %s: opened User App List" % steamid)
	counter = 0
	liste = app.AppList
	if liste:
		listenpop = popuplib.easymenu("myapps", None, PushApp)
		listenpop.settitle("My App List")
		for x in liste:
			if app.IsUseridAllowed(userid, x):
				if app.UserRunApp(userid, x):
					counter = 1
					listenpop.addoption(x, x)
		if counter:
			listenpop.send(userid)
		else:
			app.SayText("You are running #lightgreenno App", userid)
	else:
		app.SayText("You are running #lightgreenno App", userid)
		
def PushApp(userid, choice, popupid):
	userid = str(userid)
	try:
		popuplib.unsendname("AppPopup" ,userid)
	except:
		pass
	try:
		popuplib.unsendname("settings" ,userid)
	except:
		pass
	try:
		popuplib.unsendname("changegpop" ,userid)
	except:
		pass
	CurrentApp[userid] = choice
	AppPopup = popuplib.create("AppPopup")
	AppPopup.addline("App: %s" % choice)
	AppPopup.addline("-------------------------")
	Infos = app.GetInfos(choice)
	if Infos:
		try:
			AppPopup.addline("Author: %s" % Infos[2])
		except:
			pass
		try:
			AppPopup.addline("Version: %s" % Infos[0])
		except:
			pass
		try:
			AppPopup.addline("Description: %s" % Infos[1])
		except:
			pass
	else:
		AppPopup.addline("No Information given")
	AppPopup.addline("-------------------------")
	if not app.UserApps[choice]["always"]:
		if app.UserRunApp(userid, choice):
			AppPopup.addline("->1. Turn App Off")
		else:
			AppPopup.addline("->1. Turn App On")
	if app.NeedDBs[choice]:
		AppPopup.addline("->2. App Settings")
	AppPopup.addline("-------------------------")
	AppPopup.addline("0. Close")
	AppPopup.menuselect = AppSelect
	AppPopup.send(userid)
	
def AppSelect(userid, choice, popupid):
	userid = str(userid)
	steamid = es.getplayersteamid(userid)
	if choice == 1 and not app.UserApps[CurrentApp[userid]]["always"]:
		if app.CheckTimer(userid, CurrentApp[userid]):
			if app.CheckDebug("player"):
				app.PrintToLog("Steamid %s: Turned an App ON/OFF" % steamid)
			if not app.UserRunApp(userid, CurrentApp[userid]):
				app.TurnAppOn(userid, CurrentApp[userid])
				app.SayText("App %s #lightgreenis now activated" % CurrentApp[userid], userid)
			else:
				app.TurnAppOff(userid, CurrentApp[userid])
				app.SayText("App %s #lightgreenis now deactivated" % CurrentApp[userid], userid)
		PushApp(userid, CurrentApp[userid], "Popup")
	if choice == 2:
		counter = 0
		settingpop = popuplib.easymenu("settings", None, SettingApp)
		settingpop.settitle("%s Settings" % CurrentApp[userid])
		if app.AppOptions[CurrentApp[userid]]:
			for x in app.AppOptions[CurrentApp[userid]]:
				if app.IsUseridAllowedOption(userid, CurrentApp[userid], x):
					settingpop.addoption(x, x)
					counter = 1
			if counter:
				settingpop.send(userid)
			else:
				app.SayText("There are #lightgreenno App Options", userid)
		else:
			app.SayText("There are #lightgreenno App Options", userid)
			
def SettingApp(userid, choice, popupid):
	userid = str(userid)
	if app.AppOptions[CurrentApp[userid]][choice]["self"]:
		app.OpenBlock(userid, app.AppOptions[CurrentApp[userid]][choice]["selfblock"])
	else:
		counter = 0
		CurrentOpt[userid] = choice
		changegpop = popuplib.easymenu("changegpop", None, HitSettingApp)
		changegpop.settitle("App %s Settings" % CurrentApp[userid])
		if app.AppOptions[CurrentApp[userid]][choice]:
			for x in app.AppOptions[CurrentApp[userid]][choice]:
				if x != "self" and x != "selfblock" and x != "standard":
					if app.IsUseridAllowedValue(userid, CurrentApp[userid], choice, x):
						changegpop.addoption(x, app.AppOptions[CurrentApp[userid]][choice][x]["desc"])
						counter = 1
			if counter:
				changegpop.send(userid)
			else:
				app.SayText("There are #lightgreenno App Options", userid)
		else:
			app.SayText("There are #lightgreenno App Options", userid)
		
def HitSettingApp(userid, choice, popupid):
	userid = str(userid)
	steamid = es.getplayersteamid(userid)
	if app.AppOptions[CurrentApp[userid]][CurrentOpt[userid]][choice]["self"]:
		app.OpenBlock(userid, app.AppOptions[CurrentApp[userid]][CurrentOpt[userid]][choice]["selfblock"])
	else:
		if app.CheckDebug("player"):
			app.PrintToLog("Steamid %s: Changed a Setting" % steamid)
		if app.CheckTimer(userid, CurrentApp[userid]):
			app.UpdateUserOption(userid, CurrentApp[userid], CurrentOpt[userid],choice)
			app.SayText("Updated the #lightgreenValue to %s" % choice, userid)
			app.TurnTimerOn(userid, CurrentApp[userid])
		AppSelect(userid, 2, "Popup")